/*******************************************************************************
*  StatLine.cpp - bean for a single trapped line
*
*  Berzerk/
*
*  Part of the BuckoSoft Network Monitor
*  Copyright(c) 2016 - BuckoSoft, Corp.
*
\*******************************************************************************/

#include <stdio.h>

#include "server/urlencode.h"
#include "StatLine.h"

namespace berzerk {

const char crlf[] = { '\r', '\n', 0};

///////////////////////////////////////////////////////////////////////////////
string	StatLine::toXML() {
	string s;
	s += "<statline>";
	s += crlf;
	s += "<ip>";
	s += this->ip;
	s += "</ip>";
	s += crlf;
	s += "<rule>";
	s += this->rule;
	s += "</rule>";
	s += crlf;
	s += "<deathLine>";
	s += urlencode(this->deathLine);
	s += "</deathLine>";
	s += crlf;
	s += "<date>";
	s += this->getTime();
	s += "</date>";
	s += "</statline>";
	s += crlf;
	return(s);

}

///////////////////////////////////////////////////////////////////////////////
string StatLine::getTime() {
	struct tm       *tmp;
	static char     month_names[13][4] = {
			"Jan", "Feb", "Mar", "Apr", "May", "Jun",
			"Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
			"Bug"
	};
	static char     buf[80];

	tmp = localtime(&this->sldate);
	sprintf(buf, "%02d %s %02d:%02d:%02d ",
			tmp->tm_mday, month_names[tmp->tm_mon],
			tmp->tm_hour, tmp->tm_min, tmp->tm_sec);
	return buf;
}

}
