
#ifndef	_TLINE_H_
#define	_TLINE_H_

#include <string>
using namespace std;

namespace berzerk {

class TLine {
  public:
	TLine();
	TLine(const string& line, int match_start = 0, int match_length = 0, int ip_start = 0, int ip_length = 0);
	string	toXML() const;

	string	line;
	int		start;		// match start
	int		length;		// match length
	int		ipStart;	// ip match start
	int		ipLength;	// ip match length
};

inline TLine::TLine() { start = 0; length = 0; ipStart = 0; ipLength = 0;}
inline TLine::TLine(const string& line, int match_start, int match_length, int ip_start, int ip_length) {
	this->line = line; this->start = match_start; this->length = match_length;
	ipStart = ip_start; ipLength = ip_length;
}

extern TLine makeTLine(const string& s, const regex& rex, const regex& rexip);

}	// namespace berzerk

#endif	// _TLINE_H_
