/** status.js - javascript for the berzerk status page
 * 
 */

setInterval(function() {
	onloadStatus();
}, 1000*60);

function onloadStatus() {
	var d = $("#output");
	$.get("/localstats", function(response) {
		var v = $.xml2json(response);
		var h = "<table width=\"100%\" class=\"mline\">\n";
		if (v === undefined || v.length == 0) {
			d.html('N/A');
			return;
		}
		h += "<tr class=\"tbacks\"><td>Lines Read:</td><td >" + v.overview.linesRead + "</td><td>&nbsp;</td></tr>\n";
		h += "<tr class=\"tbacks\"><td>IPs Killed:</td><td>" + v.overview.ipsKilled + "</td><td>&nbsp;</td></tr>\n";
		if (v.statline !== undefined) {
			var sl = v.statline; 
			for (i=0; i<sl.length; i++) {
				var l = sl[i].deathLine;
				var x = l.replace(/\+/g, " ");
				
				h += "<tr class=\"tback" + ((i&1 == 1) ? "1" : "0") + "\">";
				h += '<td>' + sl[i].rule + '</td>';
				h += '<td colspan="2"><div class=mline>' + decodeURIComponent(x) + "</div></td>\n";
			}
		}
		h += "</table>\n";
		d.html(h);
	})
	.fail(function() {
		d.html('<div class="errorClass">status command failed</div>');
	});

}
