/** test.js - javascript for the berzerk test page
 * 
 */

var maxReturnedLines = 20;

function onloadTest() {
	$("input[type='text']").change(function() {
		processCurrentFilter();
	});
	$("select").change(function() {
		processCurrentFilter();
	});
	$("input[type='number']").change(function() {
		processCurrentFilter();
	});
	if ($("#inpIP").val() == "")
		$("#inpIP").val("\\d*\\.\\d*\.\\d*\\.\\d*");
	if ($("#inpMLines").val() == 0)
		$("#inpMLines").val(maxReturnedLines);
	getLogFiles();
}

function getLogFiles() {
	$.get("getLogFiles", function(response) {
		var v = $.xml2json(response);
		var h = "";
		if (v === undefined)
			return;
		if (v.logFile === undefined)
			return;
		v = v.logFile;
		if (isArray(v)) {
			for (var i=0; i<v.length; i++) {
				h += "<option value=\"" + i + "\">" + v[i] + "</option>\n";
			}
		} else {
			h += "<option>" + v + "</option>\n";
		}
		$("#logFiles").html(h);
		processCurrentFilter();
	})
	.fail(function() {
		$("#output").html('<div class="errorClass">getLogFiles command failed</div>');
	});
}

/**
 * url params to testFilter:
 * %d index to log file
 * %d number of results to return
 * %s regex to match
 * %s regex to fetch ip
 */
function processCurrentFilter() {
	var f = $("#logFiles option:selected").val();
	var r = $("#inpRegexp").val();
	var d = $("#output");
	maxReturnedLines = $("#inpMLines").val();
	if (maxReturnedLines < 1) {
		maxReturnedLines = 4;
		$("#inpMLines").val(4);
	}
	var args=f + "|" + maxReturnedLines + "|" + encodeURIComponent(r) + "|" + encodeURIComponent($("#inpIP").val());
	$.get("testFilter?" + args, function(response) {
		var v = $.xml2json(response);
		var h = "";
		if (v === undefined || v.length == 0 || v.Line === undefined) {
			d.html('N/A');
			return;
		}
		v = v.Line;
		if (!isArray(v)) {
			var vv = Array();
			vv[0] = v;
			v = vv;
		}
		for (var i=0; i<v.length; i++) {
			var x = v[i].replace(/\+/g, " ");
			h += '<div class=mline>' + decodeURIComponent(x) + "</div>\n";
		}
		d.html(h);
	})
	.fail(function() {
		d.html('<div class="errorClass">testfilter command failed</div>');
	});
}

/** Is this object an array?
 * @param o The object to test
 * @returns {Boolean}
 */
function isArray(o) {
	  return Object.prototype.toString.call(o) === '[object Array]'; 
}
